import 'package:flutter/material.dart';

class ColorUtils implements Colors {
  static MaterialColor getMaterialColor({int? intColor, Color? color}) {
    intColor = color != null ? color.value : intColor;
    intColor ??= color?.value;
    return MaterialColor(intColor!, <int, Color>{
      50: Color(intColor),
      100: Color(intColor),
      200: Color(intColor),
      300: Color(intColor),
      400: Color(intColor),
      500: Color(intColor),
      600: Color(intColor),
      700: Color(intColor),
      800: Color(intColor),
      900: Color(intColor),
    });
  }

  static Color adjustDarkness(Color color, double factor) {
    int value = color.value;
    int a = (value >> 24) & 0xFF;
    int r = (((value >> 16) & 0xFF) * factor).toInt();
    int g = (((value >> 8) & 0xFF) * factor).toInt();
    int b = ((value & 0xFF) * factor).toInt();
    value = (a << 24) | (r << 16) | (g << 8) | b;

    return Color(value);
  }

  static Color invert(Color color) =>
      Color((0xFFFFFF - color.value) | 0xFF000000);
}
