import 'dart:async';
import 'package:flutter/material.dart';
import 'package:adeptutils/src/interfaces/ibasic.dart';
import 'package:adeptutils/src/interfaces/ilifecycle_state.dart';

abstract class IWidget<T> extends IBasic<T> implements ILifeCycleState {
  @mustCallSuper
  int getSelectedDrawerItemId();
  bool isPressBackAgain();
  void pressBackAgain(bool pressBackAgain,
      {String pressBackAgainMessage = "Press back again to exit"});
  void onBuildCompleted();
  Future<bool> onBackPressed();
  void pop<T extends Object?>({BuildContext? context, T? result});
  Future<T?>? push<T extends Object?>(
      {BuildContext? context,
      Route<T>? route,
      String? routeName,
      Widget? widget});
  Future<T?>? pushReplacement<T extends Object?, TO extends Object?>(
      {BuildContext? context,
      Route<T>? newRoute,
      String? newRouteName,
      Widget? newWidget,
      TO? result});
}
